/**
 * Copyright &copy; 2015-2020 <a href="http://www.jeeplus.org/">JeePlus</a> All rights reserved.
 */
package com.jeeplus.modules.workcontent.web;

import com.google.common.collect.Lists;
import com.jeeplus.common.config.Global;
import com.jeeplus.common.persistence.Page;
import com.jeeplus.common.utils.DateUtils;
import com.jeeplus.common.utils.MyBeanUtils;
import com.jeeplus.common.utils.StringUtils;
import com.jeeplus.common.utils.excel.ExportExcel;
import com.jeeplus.common.utils.excel.ImportExcel;
import com.jeeplus.common.web.BaseController;
import com.jeeplus.modules.workcontent.dao.WorkContentAltermanageDao;
import com.jeeplus.modules.workcontent.dao.WorkContentClaimDao;
import com.jeeplus.modules.workcontent.dao.WorkContentContractinfoDao;
import com.jeeplus.modules.workcontent.entity.*;
import com.jeeplus.modules.workcontent.service.WorkContentContractSumService;
import org.apache.shiro.authz.annotation.Logical;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.servlet.mvc.support.RedirectAttributes;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.validation.ConstraintViolationException;
import java.util.ArrayList;
import java.util.List;

/**
 * 合同登记Controller
 * @author ssrh
 * @version 2018-06-12
 */
@Controller
@RequestMapping(value = "${adminPath}/workcontent/workContentContractSum")
public class WorkContentContractSumController extends BaseController {

	@Autowired
	private WorkContentContractSumService workContentContractSumService;
	@Autowired
	private WorkContentAltermanageDao workContentAltermanageDao;
	@Autowired
	private WorkContentClaimDao workContentClaimDao;
	@Autowired
	private WorkContentContractinfoDao workContentContractinfoDao;
	
	@ModelAttribute
	public WorkContentContractSum get(@RequestParam(required=false) String id) {
		WorkContentContractSum entity = null;
		if (StringUtils.isNotBlank(id)){
			entity = workContentContractSumService.get(id);
		}
		if (entity == null){
			entity = new WorkContentContractSum();
		}
		return entity;
	}
	
	/**
	 * 合同登记列表页面
	 */
	@RequiresPermissions("workcontent:workContentContractSum:list")
	@RequestMapping(value = {"list", ""})
	public String list(WorkContentContractSum workContentContractSum, HttpServletRequest request, HttpServletResponse response, Model model) {
		Page<WorkContentContractSum> page = workContentContractSumService.findPage(new Page<WorkContentContractSum>(request, response), workContentContractSum); 
		model.addAttribute("page", page);
		return "modules/workcontent/workContentContractSumList";
	}

	/**
	 * 查看，增加，编辑合同登记表单页面
	 */
	@RequestMapping(value = "form")
	public String form(WorkContentContractSum workContentContractSum,String view, Model model) {
		WorkContentContractSum oldRecord = null;
		String name = "";//合同名称
		double alertFee = 0.00;
		double claimFee = 0.00;
		if(StringUtils.isNotBlank(workContentContractSum.getContentId())){
			List<WorkContentContractSum> list = workContentContractSumService.findList(workContentContractSum);
			if(list!=null&&!list.isEmpty()){
				oldRecord = list.get(0);
			}
		}
		if(oldRecord!=null){
			String conId = oldRecord.getContentId();
			//获取变更信息
			//List<WorkContentAltermanage> workContentAltermanages = workContentAltermanageDao.findByConId(conId);
			//获取变更信息和索赔信息
			List<WorkContentClaim> workContentClaims = workContentClaimDao.findByConId(conId);
			//获取合同信息
			List<WorkContentContractinfo> workContentContractinfos = workContentContractinfoDao.findByConId(conId);
			List<WorkContentSummary> list = new ArrayList();
			WorkContentSummary workContentSummary = null;
			//初始化一个金额
			Double originalMoney = null;
			if(null != workContentContractinfos && workContentContractinfos.size() >0){
				for(WorkContentContractinfo workContentContractinfo : workContentContractinfos) {
					workContentSummary = new WorkContentSummary();
					workContentSummary.setType("合同信息");
					workContentSummary.setName(name);
					workContentSummary.setDate(workContentContractinfo.getUpdateDate());
					if (null != workContentContractinfo.getTrueAmt()) {
						workContentSummary.setAdjustMoney(workContentContractinfo.getTrueAmt());
						workContentSummary.setMoney(0D);
					}else{
						workContentSummary.setMoney(workContentContractinfo.getTrueAmt());
					}
					workContentSummary.setProContentName(workContentContractinfo.getProConTentName());
					workContentSummary.setCreateName(workContentContractinfo.getCreateName());
					originalMoney = workContentContractinfo.getTrueAmt();
					list.add(workContentSummary);
				}
			}
			/*if(null != workContentAltermanages && workContentAltermanages.size() >0){
				for(WorkContentAltermanage workContentAltermanage : workContentAltermanages) {
					workContentSummary = new WorkContentSummary();
					workContentSummary.setType(workContentAltermanage.getTypeName());
					workContentSummary.setDate(workContentAltermanage.getUpdateDate());
					workContentSummary.setMoney(workContentAltermanage.getSetAmt());
					workContentSummary.setProContentName(workContentAltermanage.getProConTentName());
					workContentSummary.setCreateName(workContentAltermanage.getCreateName());
					list.add(workContentSummary);
				}
			}*/
			if(null != workContentClaims && workContentClaims.size() >0){
				for(WorkContentClaim workContentClaim : workContentClaims) {
					workContentSummary = new WorkContentSummary();
					workContentSummary.setType(workContentClaim.getTypeName());
					workContentSummary.setDate(workContentClaim.getUpdateDate());
					workContentSummary.setMoney(workContentClaim.getSetAmt());
					if (null != originalMoney) {
						workContentSummary.setAdjustMoney(originalMoney - workContentClaim.getSetAmt());
						originalMoney = workContentSummary.getAdjustMoney();
					}
					workContentSummary.setProContentName(workContentClaim.getProConTentName());
					workContentSummary.setCreateName(workContentClaim.getCreateName());
					list.add(workContentSummary);
				}
			}
			oldRecord.setWorkContentSummaries(list);
			model.addAttribute("workContentContractSum", oldRecord);
		}else {
			model.addAttribute("workContentContractSum", workContentContractSum);
		}
		;

		return "modules/workcontent/workContentContractSumFormView";
	}

	/**
	 * 保存合同登记
	 */
	@RequiresPermissions(value={"workcontent:workContentContractSum:add","workcontent:workContentContractSum:edit"},logical=Logical.OR)
	@RequestMapping(value = "save")
	public String save(WorkContentContractSum workContentContractSum, Model model, RedirectAttributes redirectAttributes) throws Exception{
		if (!beanValidator(model, workContentContractSum)){
			return form(workContentContractSum,null, model);
		}
		if(!workContentContractSum.getIsNewRecord()){//编辑表单保存
			WorkContentContractSum t = workContentContractSumService.get(workContentContractSum.getId());//从数据库取出记录的值
			MyBeanUtils.copyBeanNotNull2Bean(workContentContractSum, t);//将编辑表单中的非NULL值覆盖数据库记录中的值
			workContentContractSumService.save(t);//保存
		}else{//新增表单保存
			workContentContractSumService.save(workContentContractSum);//保存
		}
		addMessage(redirectAttributes, "保存合同登记成功");
		return "redirect:"+Global.getAdminPath()+"/workcontent/workContentContractSum/?repage";
	}
	
	/**
	 * 删除合同登记
	 */
	@RequiresPermissions("workcontent:workContentContractSum:del")
	@RequestMapping(value = "delete")
	public String delete(WorkContentContractSum workContentContractSum, RedirectAttributes redirectAttributes) {
		workContentContractSumService.delete(workContentContractSum);
		addMessage(redirectAttributes, "删除合同登记成功");
		return "redirect:"+Global.getAdminPath()+"/workcontent/workContentContractSum/?repage";
	}
	
	/**
	 * 批量删除合同登记
	 */
	@RequiresPermissions("workcontent:workContentContractSum:del")
	@RequestMapping(value = "deleteAll")
	public String deleteAll(String ids, RedirectAttributes redirectAttributes) {
		String idArray[] =ids.split(",");
		for(String id : idArray){
			workContentContractSumService.delete(workContentContractSumService.get(id));
		}
		addMessage(redirectAttributes, "删除合同登记成功");
		return "redirect:"+Global.getAdminPath()+"/workcontent/workContentContractSum/?repage";
	}
	
	/**
	 * 导出excel文件
	 */
	@RequiresPermissions("workcontent:workContentContractSum:export")
    @RequestMapping(value = "export", method=RequestMethod.POST)
    public String exportFile(WorkContentContractSum workContentContractSum, HttpServletRequest request, HttpServletResponse response, RedirectAttributes redirectAttributes) {
		try {
            String fileName = "合同登记"+DateUtils.getDate("yyyyMMddHHmmss")+".xlsx";
            Page<WorkContentContractSum> page = workContentContractSumService.findPage(new Page<WorkContentContractSum>(request, response, -1), workContentContractSum);
    		new ExportExcel("合同登记", WorkContentContractSum.class).setDataList(page.getList()).write(response, fileName).dispose();
    		return null;
		} catch (Exception e) {
			addMessage(redirectAttributes, "导出合同登记记录失败！失败信息："+e.getMessage());
		}
		return "redirect:"+Global.getAdminPath()+"/workcontent/workContentContractSum/?repage";
    }

	/**
	 * 导入Excel数据

	 */
	@RequiresPermissions("workcontent:workContentContractSum:import")
    @RequestMapping(value = "import", method=RequestMethod.POST)
    public String importFile(MultipartFile file, RedirectAttributes redirectAttributes) {
		try {
			int successNum = 0;
			int failureNum = 0;
			StringBuilder failureMsg = new StringBuilder();
			ImportExcel ei = new ImportExcel(file, 1, 0);
			List<WorkContentContractSum> list = ei.getDataList(WorkContentContractSum.class);
			for (WorkContentContractSum workContentContractSum : list){
				try{
					workContentContractSumService.save(workContentContractSum);
					successNum++;
				}catch(ConstraintViolationException ex){
					failureNum++;
				}catch (Exception ex) {
					failureNum++;
				}
			}
			if (failureNum>0){
				failureMsg.insert(0, "，失败 "+failureNum+" 条合同登记记录。");
			}
			addMessage(redirectAttributes, "已成功导入 "+successNum+" 条合同登记记录"+failureMsg);
		} catch (Exception e) {
			addMessage(redirectAttributes, "导入合同登记失败！失败信息："+e.getMessage());
		}
		return "redirect:"+Global.getAdminPath()+"/workcontent/workContentContractSum/?repage";
    }
	
	/**
	 * 下载导入合同登记数据模板
	 */
	@RequiresPermissions("workcontent:workContentContractSum:import")
    @RequestMapping(value = "import/template")
    public String importFileTemplate(HttpServletResponse response, RedirectAttributes redirectAttributes) {
		try {
            String fileName = "合同登记数据导入模板.xlsx";
    		List<WorkContentContractSum> list = Lists.newArrayList(); 
    		new ExportExcel("合同登记数据", WorkContentContractSum.class, 1).setDataList(list).write(response, fileName).dispose();
    		return null;
		} catch (Exception e) {
			addMessage(redirectAttributes, "导入模板下载失败！失败信息："+e.getMessage());
		}
		return "redirect:"+Global.getAdminPath()+"/workcontent/workContentContractSum/?repage";
    }
	
	
	

}